﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using FiwareProyecto.BaseDeDatos;

namespace FiwareProyecto.Controllers
{
    public class LoginController : CheckSecurity
    {
        LoginBBDD db = new LoginBBDD();
        FiwareEntities db1 = new FiwareEntities();


        // GET: Login
        public ActionResult Index(string message = "")
        {
            ViewBag.Message = message;
            
            return View();
        }

        [HttpPost]
        public ActionResult Login (string usuario, string pass)
        {
            Usuario Logado = new Usuario();
            bool esAdmin = false;
            using (var db = new FiwareEntities()) {
                Logado = db.Usuario.FirstOrDefault(u=>u.email == usuario);

                if (Logado == null)
                {
                    return RedirectToAction("Index", new { message = "No encontramos sus datos" });
                }
                else
                {

                    esAdmin = ObtenerRol(Logado);
                }
              
            }
            ControllerContext.HttpContext.Response.SetCookie(new HttpCookie("Email", usuario));
            controlUsuario();

           
            int? idUser = 0;     
            bool existe = db.Login(usuario, pass, out idUser);        
            if (existe)
            {
                FormsAuthentication.SetAuthCookie(existe.ToString(), true);
                ControllerContext.HttpContext.Response.SetCookie(new HttpCookie("Email", usuario));
                Session["idUser"] = idUser;


                ViewBag.logado = Logado.email;

                return Redirect("/Home/Index");
            }
            else
            {
                //return Redirect("/Login/Index");
                return RedirectToAction("Index", new { message = "No encontramos sus datos" });
            }          
        }

    

        [Authorize]
        public ActionResult Logout()
        {
            FormsAuthentication.SignOut();
            ControllerContext.HttpContext.Response.SetCookie(new HttpCookie("Email", null));
            Session.Abandon();
            return Redirect("/Login/Index");

        }

    

    }
}