﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Threading.Tasks;
using FiwareProyecto.Models;
using FiwareProyecto.Models.ViewModels;
using System.Net.Http;
using FiwareProyecto.BaseDeDatos;

namespace FiwareProyecto.Controllers
{
    public class PlazasController : CheckSecurity
    {
        private FiwareEntities db = new FiwareEntities();
        LoginBBDD db1 = new LoginBBDD();
        PlazaModel model;
        public PlazasController()
        {
            this.model = new PlazaModel();
        }

       
        // GET: Contacts
        [AsyncTimeout(1000)]
        public async Task<ActionResult> Index()
        {

            Usuario Logado = new Usuario();
            if (Session["idUser"] == null)
            {
                return Redirect("/Login/Index");
            }
            else
            {
                bool esAdmin = false;
                string usuario = "";
                string pass = "";
                int? idUser = 0;
                var usuLogado = controlUsuario();
                bool existe = db1.Login(usuario, pass, out idUser);
                using (var db = new FiwareEntities())
                {
                    Logado = db.Usuario.FirstOrDefault(u => u.email == usuLogado.email);
                    esAdmin = ObtenerRol(Logado);

                }

              

                ViewBag.logado = Logado.email;

                List<Plazas> cList = await model.GetContacts();
                return View(cList);
            }
        }

        // GET: Contacts
        [AsyncTimeout(1000)]
        public async Task<ActionResult> IndexP()
        {
            Usuario Logado = new Usuario();
            if (Session["idUser"] == null)
            {
                return Redirect("/Login/Index");
            }
            else
            {
                bool esAdmin = false;
                string usuario = "";
                string pass = "";
                int? idUser = 0;
                var usuLogado = controlUsuario();
                bool existe = db1.Login(usuario, pass, out idUser);
                using (var db = new FiwareEntities())
                {
                    Logado = db.Usuario.FirstOrDefault(u => u.email == usuLogado.email);
                    esAdmin = ObtenerRol(Logado);

                }



                ViewBag.logado = Logado.email;
                List<Plazas> cList = await model.GetContacts();
                return View(cList);
            }
        }

        // GET: Contacts/Details/5
        public async Task<ActionResult> Details(string id)
        {
            Plazas c = await model.GetContactByID(id);
            return View(c);
        }

        // GET: Contacts/Create
        //public async Task<ActionResult> Create()
        //{
        //    return View();
        //}

        //// POST: Contacts/Create
        //[HttpPost]
        //public async Task<ActionResult> Create(Plazas c)
        //{
        //    try
        //    {
        //        await model.AddContact(c);
        //        return RedirectToAction("Index");
        //    }
        //    catch
        //    {
        //        return View();
        //    }
        //}




        public ActionResult create()
        {
            return View();
        }

        [HttpPost]
        public ActionResult create(PlazasViewModel plazas)
        {
            using (var client = new HttpClient())
            {
                client.BaseAddress = new Uri("http://192.168.91.137:1026/v2/entities/");
                //client.BaseAddress = new Uri("https://jsonplaceholder.typicode.com/posts");

                //HTTP POST
                var postTask = client.PostAsJsonAsync<PlazasViewModel>("http://192.168.91.137:1026/v2/entities/", plazas);
                //var postTask = client.PostAsJsonAsync<StudentViewModel>("https://jsonplaceholder.typicode.com/posts", student); 
                postTask.Wait();

                var result = postTask.Result;
                if (result.IsSuccessStatusCode)
                {
                    if (plazas.type == "Plaza-Segovia")
                    {
                        return RedirectToAction("IndexP");
                    }
                    else
                    {
                        return RedirectToAction("Index");
                    }
                }
            }

            ModelState.AddModelError(string.Empty, "Server Error. Please contact administrator.");

            return View(plazas);
        }


        // GET: Contacts/Edit/5
        public async Task<ActionResult> Edit(string id)
        {
            Plazas c = await model.GetContactByID(id);
            return View(c);
        }

        // POST: Contacts/Edit/5
        [HttpPost]
        public async Task<ActionResult> Edit(Plazas c)
        {
            try
            {
                await model.EditContact(c);
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Contacts/Delete/5
        public async Task<ActionResult> Delete(string id)
        {
            await model.DeleteContact(id);
            return RedirectToAction("Index");
        }
    }
}
