﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using FiwareProyecto;
using FiwareProyecto.BaseDeDatos;
using FiwareProyecto.Models.ViewModels;

namespace FiwareProyecto.Controllers
{
    public class ReservasCanceladasController : CheckSecurity
    {
        private FiwareEntities db = new FiwareEntities();
        LoginBBDD db1 = new LoginBBDD();

        // GET: Reservas
        public ActionResult Index(string messageReservas = "")
        {
            ViewBag.MessageReservas = messageReservas;
            Reserva UsuRes = new Reserva();
            Usuario Logado = new Usuario();
            if (Session["idUser"] == null)
            {
                return Redirect("/Login/Index");
            }
            else
            {
                bool esAdmin = false;
                string usuario = "";
                string pass = "";
                int? idUser = 0;
                var usuLogado = controlUsuario();
                bool existe = db1.Login(usuario, pass, out idUser);
                using (var db = new FiwareEntities())
                {
                    Logado = db.Usuario.FirstOrDefault(u => u.email == usuLogado.email);
                    esAdmin = ObtenerRol(Logado);

                }

                ViewBag.logado = Logado.email;
                ViewBag.Admin = esAdmin;

                UsuRes.Usuario = db.Usuario.Where(c => c.idUsuario == usuLogado.idUsuario).ToList();

                var lista = esAdmin ? db.Usuario.ToList() : db.Usuario.Where(u => u.email == usuLogado.email && u.password == usuLogado.password).ToList();

             

                if (Session["idUser"] == null)
                {
                    return Redirect("/Login/Index");
                }
                else
                {
                    var usuarioReserva = db.Usuario.Where(u => u.email == usuLogado.email && u.password == usuLogado.password).FirstOrDefault();
                    //Con esta query vemos las reservas hechas de cada usuario
                    var listaReserva = from r in db.Reserva
                                       where r.Usuario.Any(u => u.idUsuario == usuarioReserva.idUsuario)
                                       select r;

                    DateTime hoy = DateTime.Now;
                    DateTime fecha = hoy.AddDays(-3);
                    //DateTime fechaNoFAC = hoy.AddDays(-5);



                    // var fecha = DateTime.Today.AddDays(-3);
                    var facturadas = db.Reserva.Where(c=>c.fechaSalida < fecha).ToList();

                    //var query = db.Usuario.Where(c => c.idUsuario == usuarioReserva.idUsuario)
                    //    .SelectMany(c => c.Reserva);
                    //var query = db.Usuario.Where(c => c.idUsuario == usuarioReserva.idUsuario).SelectMany(c => Reserva);

                    if (esAdmin)
                    {
                        //return View(db.Reserva.Where(c=>c.fechaSalida >= fecha).ToList());
                        return View(db.Reserva.Where(c => c.activo == false).ToList());
                    }
                    else
                    {
                        //var cd = listaReserva.Where(c => c.fechaSalida < DateTime.Now && c.activo == true).ToList();

                    


                        //return View(listaReserva);


                        return View(listaReserva.Where(c => c.activo == false).ToList());



                    }
                }
            }
        }
        // GET: Reservas/Details/5
        //public ActionResult Details(int? id)
        //{
        //    if (id == null)
        //    {
        //        return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
        //    }
        //    Reserva reserva = db.Reserva.Find(id);
        //    if (reserva == null)
        //    {
        //        return HttpNotFound();
        //    }
        //    return View(reserva);
        //}

        //// GET: Reservas/Create
        //public ActionResult Create()
        //{
        //    return View();
        //}

        //// POST: Reservas/Create
        //// Para protegerse de ataques de publicación excesiva, habilite las propiedades específicas a las que desea enlazarse. Para obtener 
        //// más información vea https://go.microsoft.com/fwlink/?LinkId=317598.
        //[HttpPost]
        //[ValidateAntiForgeryToken]
        //public ActionResult Create([Bind(Include = "idReserva,idPlaza,fechaEntrada,fechaSalida,activo,parking")] Reserva reserva)
        //{

        //    Usuario Logado = new Usuario();
        //    bool esAdmin = false;
        //    string usuario = "";
        //    string pass = "";
        //    int? idUser = 0;
        //    var usuLogado = controlUsuario();
        //    bool existe = db1.Login(usuario, pass, out idUser);
        //    using (var db = new FiwareEntities())
        //    {
        //        Logado = db.Usuario.FirstOrDefault(u => u.email == usuLogado.email);
        //        esAdmin = ObtenerRol(Logado);
        //    }
        //    var lista = esAdmin ? db.Usuario.ToList() : db.Usuario.Where(u => u.email == usuLogado.email && u.password == usuLogado.password).ToList();


        //    if (ModelState.IsValid)
        //    {
        //        //Comprobamos si esa reserva esta disponible
        //        var ReservaExiste = db.Reserva.Count(c => (c.fechaEntrada == reserva.fechaEntrada ||
        //         c.fechaSalida == reserva.fechaSalida || c.idPlaza == reserva.idPlaza) && c.parking == reserva.parking && reserva.activo == true);

        //        var ReservaExiste1 = db.Reserva.Where(c => (c.fechaEntrada == reserva.fechaEntrada ||
        //           c.fechaSalida == reserva.fechaSalida) && c.idPlaza == reserva.idPlaza && c.parking == reserva.parking).ToList();
        //        var a = ReservaExiste1.Select(d => d.fechaSalida);

        //        ViewBag.fechaFin = a.ToString();

        //        var finReserva = db.Reserva.Where(c => c.fechaSalida < DateTime.Now).ToList();



        //        if (ReservaExiste > 0)
        //        {

        //            return RedirectToAction("Index", new { messageReservas = "La plaza esta ocupada" });

        //        }
        //        else if (reserva.fechaSalida < DateTime.Now)
        //        {
        //            reserva.activo = false;

        //            db.Reserva.Add(reserva);
        //            reserva.Usuario = db.Usuario.Where(u => u.idUsuario == usuLogado.idUsuario).ToList();
        //            db.SaveChanges();
        //            return RedirectToAction("Index");
        //        }
        //        else
        //        {
        //            reserva.activo = true;
        //            db.Reserva.Add(reserva);
        //            reserva.Usuario = db.Usuario.Where(u => u.idUsuario == usuLogado.idUsuario).ToList();
        //            db.SaveChanges();
        //            return RedirectToAction("Index");
        //        }
        //    }
        //    return View(reserva);
        //}

        //// GET: Reservas/Edit/5
        //public async Task<ActionResult> Edit(int? id)
        //{
        //    if (id == null)
        //    {
        //        return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
        //    }
        //    var proy = await db.Reserva.FirstOrDefaultAsync(p => p.idReserva == id);
        //   // Reserva reserva = db.Reserva.Find(id);
        //    if (proy == null)
        //    {
        //        return HttpNotFound();
        //    }
        //    return View(new ReservasViewModel()
        //    {
        //        idReserva = proy.idReserva,
        //        Usuarios = db.Usuario.ToList(),
        //        activo = proy.activo,
        //        fechaEntrada = proy.fechaEntrada,
        //        fechaSalida = proy.fechaSalida,
        //        idPlaza = proy.idPlaza
        //    });
        //}

        //// POST: Reservas/Edit/5
        //// Para protegerse de ataques de publicación excesiva, habilite las propiedades específicas a las que desea enlazarse. Para obtener 
        //// más información vea https://go.microsoft.com/fwlink/?LinkId=317598.
        //[HttpPost]
        //[ValidateAntiForgeryToken]
        //public async Task<ActionResult> Edit(ReservasViewModel proy)
        //{
        //    if (!ModelState.IsValid) return View(proy);
        //    var pro = db.Reserva.Find(proy.idReserva);
        //    if (pro == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
        //    //pro.Usuario.Clear();
        //    //pro.Usuario = db.Usuario.ToList();

        //    pro.Usuario = db.Usuario.Where(c => c.idUsuario == proy.idUsuario).ToList();
        //    pro.activo = proy.activo;
        //    pro.fechaEntrada = proy.fechaEntrada;
        //    pro.fechaSalida = proy.fechaSalida;
        //    pro.idPlaza = proy.idPlaza;

        //    await db.SaveChangesAsync();
        //    return RedirectToAction("Index");
        //}
        //// GET: Reservas/Delete/5
        //public ActionResult Delete(int? id)
        //{
        //    if (id == null)
        //    {
        //        return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
        //    }
        //    Reserva reserva = db.Reserva.Find(id);
        //    if (reserva == null)
        //    {
        //        return HttpNotFound();
        //    }
        //    return View(reserva);
        //}

        //// POST: Reservas/Delete/5
        //[HttpPost, ActionName("Delete")]
        //[ValidateAntiForgeryToken]
        //public ActionResult DeleteConfirmed(int id)
        //{
        //    Reserva reserva = db.Reserva.Find(id);
        //    db.Reserva.Remove(reserva);
        //    db.SaveChanges();
        //    return RedirectToAction("Index");
        //}   
        //protected override void Dispose(bool disposing)
        //{
        //    if (disposing)
        //    {
        //        db.Dispose();
        //    }
        //    base.Dispose(disposing);
        //}
    }
}
