﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using FiwareProyecto;
using FiwareProyecto.BaseDeDatos;
using FiwareProyecto.Models.ViewModels;

namespace FiwareProyecto.Controllers
{
  
    public class UsuariosController : CheckSecurity
    {
        private FiwareEntities db = new FiwareEntities();
        LoginBBDD db1 = new LoginBBDD();

        // GET: Usuarios
        public ActionResult Index()
        {
       
            Usuario Logado = new Usuario();

            if (Session["idUser"] == null)
            {
                return Redirect("/Login/Index");
            }
            else
            {

                bool esAdmin = false;
                string usuario = "";
                string pass = "";           
                int? idUser = 0;
                var usuLogado = controlUsuario();
                bool existe = db1.Login(usuario, pass, out idUser);
                using (var db = new FiwareEntities())
                {
                    Logado = db.Usuario.FirstOrDefault(u => u.email == usuLogado.email);
                    esAdmin = ObtenerRol(Logado);
                }

                ViewBag.logado = Logado.email;

                ViewBag.admin = esAdmin;



                var lista = esAdmin ? db.Usuario.ToList() : db.Usuario.Where(u => u.email == usuLogado.email && u.password == usuLogado.password).ToList();


                if (Session["idUser"] == null)
                {
                    return Redirect("/Login/Index");
                }
                else
                {
                    return View(lista);
                }

            }
            
        }

        // GET: Usuarios/Details/5
        public ActionResult Details(int? id)
        {
            if (Session["idUser"] == null)
            {
                return Redirect("/Login/Index");
            }
            else
            {
                if (id == null)
                {
                    return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
                }
                Usuario usuario = db.Usuario.Find(id);
                if (usuario == null)
                {
                    return HttpNotFound();
                }
                return View(usuario);
            }
        }

        // GET: Usuarios/Create
        public ActionResult Create(string messageEmail = "")
        {

            ViewBag.MessageEmail = messageEmail;

            return View();

        }

        //POST: Usuarios/Create
        //Para protegerse de ataques de publicación excesiva, habilite las propiedades específicas a las que desea enlazarse.Para obtener
        //más información vea https://go.microsoft.com/fwlink/?LinkId=317598.

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "idUsuario,email,nombre,apellidos,telefono,fechaBaja,fechaBorrado,password")] Usuario usuario)
        {


            Usuario Logado = new Usuario();
        

            if (Session["idUser"] == null)
            {

                if (ModelState.IsValid)
                {
                   
                    db.Roles.Where(r => r.idRol == 2).ToList();

                 
                    usuario.fechaAlta = DateTime.Now;
                    usuario.activo = true;
                    usuario.password = CheckSecurity.GetSHA256(usuario.password);                    
                    usuario.Roles = db.Roles.Where(c => c.idRol == 2).ToList();
                    db.Usuario.Add(usuario);

                    bool existeEmail = db.Usuario.Any(x => x.email == usuario.email);

                    if (existeEmail)
                    {
                        return RedirectToAction("Create", new { messageEmail = "El email ya existe, compruebe sus datos o pongase en contacto con el servicio técnico" });
                    }
                    else
                    {
                        db.SaveChanges();
                        return Redirect("/Login/Index");
                    }
                }           
            }
                return View(usuario);

        }


        // GET: Usuarios/Edit/5
        //public ActionResult Edit(int? id)
        //{

        //    if (Session["idUser"] == null)
        //    {
        //        return Redirect("/Login/Index");
        //    }
        //    else
        //    {
        //        if (id == null)
        //        {
        //            return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
        //        }
        //        Usuario usuario = db.Usuario.Find(id);
        //        if (usuario == null)
        //        {
        //            return HttpNotFound();
        //        }
        //        return View(usuario);
        //    }
        //}

        public async Task<ActionResult> Edit(int? id, string messageEdit = "")
        {
            //Reserva reserva = db.Reserva.Include(u => u.Usuario).ToList().Find(d => d.idReserva == id);
            Usuario Logado = new Usuario();

            ViewBag.MessageEdit = messageEdit;

            if (Session["idUser"] == null)
            {
                return Redirect("/Login/Index");
            }
            else
            {

                bool esAdmin = false;
                string usuario = "";
                string pass = "";
                int? idUser = 0;
                var usuLogado = controlUsuario();
                bool existe = db1.Login(usuario, pass, out idUser);
                using (var db = new FiwareEntities())
                {
                    Logado = db.Usuario.FirstOrDefault(u => u.email == usuLogado.email);
                    esAdmin = ObtenerRol(Logado);
                }

                ViewBag.logado = Logado.email;

                ViewBag.admin = esAdmin;

                if (id == null)
                {
                    return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
                }

                var proy = await db.Usuario.FirstOrDefaultAsync(p => p.idUsuario == id);
                // Reserva reserva = db.Reserva.Find(id);
                if (proy == null)
                {
                    return HttpNotFound();
                }

                return View(new UserViewModel()
                {
                    idUsuario = proy.idUsuario,
                    Roles = db.Roles.ToList(),
                    activo = proy.activo,
                    fechaAlta = proy.fechaAlta,
                    fechaBaja = proy.fechaBaja,
                    fechaBorrado = proy.fechaBorrado,
                    nombre = proy.nombre,
                    apellidos = proy.apellidos,
                    telefono = proy.telefono,
                    password = proy.password
                });
            }
        }


        // POST: Reservas/Edit/5
        // Para protegerse de ataques de publicación excesiva, habilite las propiedades específicas a las que desea enlazarse. Para obtener 
        // más información vea https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        //public ActionResult Edit([Bind(Include = "idReserva,idPlaza,fechaEntrada,fechaSalida,activo,parking")] Reserva reserva)
        //{
        public async Task<ActionResult> Edit(UserViewModel proy)
        {
            Usuario Logado = new Usuario();

            if (Session["idUser"] == null)
            {
                return Redirect("/Login/Index");
            }
            else
            {

                bool esAdmin = false;
                string usuario = "";
                string pass = "";
                int? idUser = 0;
                var usuLogado = controlUsuario();
                bool existe = db1.Login(usuario, pass, out idUser);
                using (var db = new FiwareEntities())
                {
                    Logado = db.Usuario.FirstOrDefault(u => u.email == usuLogado.email);
                    esAdmin = ObtenerRol(Logado);
                }

                ViewBag.logado = Logado.email;

                ViewBag.admin = esAdmin;



                //if (!ModelState.IsValid) return View(proy);
                var pro = db.Usuario.Find(proy.idUsuario);
                if (pro == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
                //pro.Usuario.Clear();
                //pro.Usuario = db.Usuario.ToList();

                var usuarioReserva = db.Usuario.Where(u => u.email == usuLogado.email && u.password == usuLogado.password).FirstOrDefault();
                //Con esta query vemos las reservas hechas de cada usuario
                var listaReserva = from r in db.Reserva
                                   where r.Usuario.Any(u => u.idUsuario == usuarioReserva.idUsuario)
                                   select r;


                pro.Roles = db.Roles.Where(c => c.idRol == proy.idUsuario).ToList();
              
                if(listaReserva.Any(c=>c.activo == true && proy.activo == false))
                {
                    return RedirectToAction("Edit", new { messageEdit = "Debe cancelar sus reservas antes de darse de baja" });
                }

                pro.activo = proy.activo;
                pro.fechaBaja = proy.fechaBaja;
                if (proy.activo == false)
                {
                    proy.fechaBaja = DateTime.Now;
                    proy.fechaBorrado = DateTime.Today.AddDays(15);
                }

                pro.activo = proy.activo;
                pro.fechaBaja = proy.fechaBaja;
                pro.fechaBorrado = proy.fechaBorrado;
                // pro.fechaAlta = proy.fechaAlta;
                // pro.fechaBaja = proy.fechaBaja;
                pro.idUsuario = proy.idUsuario;

                if(proy.activo == true)
                {
                    proy.fechaBaja = null;
                    proy.fechaBorrado = null;
                }

                pro.activo = proy.activo;
                pro.fechaBaja = proy.fechaBaja;
                pro.fechaBorrado = proy.fechaBorrado;
                 pro.nombre = proy.nombre;
                pro.apellidos = proy.apellidos;
                pro.telefono = proy.telefono;
                //            pro.password = CheckSecurity.GetSHA256(proy.password);



                await db.SaveChangesAsync();
                return RedirectToAction("Index");


            }
        }

        //// POST: Usuarios/Edit/5
        //// Para protegerse de ataques de publicación excesiva, habilite las propiedades específicas a las que desea enlazarse. Para obtener 
        //// más información vea https://go.microsoft.com/fwlink/?LinkId=317598.
        //[HttpPost]
        //[ValidateAntiForgeryToken]
        //public ActionResult Edit([Bind(Include = "idUsuario,email,nombre,apellidos,telefono,fechaAlta,fechaBaja,fechaBorrado,activo,password")] Usuario usuario)
        //{
        //    if (Session["idUser"] == null)
        //    {
        //        return Redirect("/Login/Index");
        //    }
        //    else
        //    {

        //        if (ModelState.IsValid)
        //        {
        //            if(usuario.activo == false)
        //            {
        //                usuario.fechaBaja = DateTime.Now;
        //            }
        //            usuario.password = CheckSecurity.GetSHA256(usuario.password);
        //            db.Entry(usuario).State = EntityState.Modified;
        //            db.SaveChanges();
        //            return RedirectToAction("Index");
        //        }
        //        return View(usuario);
        //    }
        //}

        //GET: Usuarios/Delete/5
        public ActionResult Delete(int? id, string messageEdit = "")
        {
            ViewBag.MessageEdit = messageEdit;
            if (Session["idUser"] == null)
            {
                return Redirect("/Login/Index");
            }
            else
            {
                if (id == null)
                {
                    return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
                }
                Usuario usuario = db.Usuario.Find(id);
        
                if (usuario == null)
                {
                    return HttpNotFound();
                }
                return View(usuario);
            }
        }

        // POST: Usuarios/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {


            if (Session["idUser"] == null)
            {
                return Redirect("/Login/Index");
            }
            else
            {
                Usuario usuario = db.Usuario.Find(id);


                //Para borrar usuario
                var objUser = (from p in usuario.Roles
                    where p.idRol == id
                    select p).FirstOrDefault();

                usuario.Roles.Remove(objUser);

                if (usuario.fechaBaja == null)
                {
                    return RedirectToAction("Delete", new { messageEdit = "El usuario debe de tener fecha de baja" });
                }

          usuario.fechaBorrado = DateTime.Now;
                usuario.activo = false;         
                
                db.Usuario.Remove(usuario);           

                db.SaveChanges();
                return RedirectToAction("Index");



            }
        }

        //[HttpPost]
        //public ActionResult Delete(int Id)
        //{
        //    using (var db = new FiwareEntities())
        //    {
        //        var oUser = db.Usuario.Find(Id);

        //        if (oUser.activo == false)
        //        {
        //            oUser.fechaBorrado = DateTime.Now;
        //        }
        //        //oUser.activo == true; //eliminaremos  


        //        db.Entry(oUser).State = System.Data.Entity.EntityState.Modified;
        //        db.SaveChanges();


        //    }
        //    return Content("1");
        //}

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}
