﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

using System.Net.Http;
using System.Net.Http.Headers;
using System.Threading.Tasks;

namespace FiwareProyecto.Models
{
    public class ParkingModel
    {
        private String UriApi;
        MediaTypeWithQualityHeaderValue mediaheader;
        public ParkingModel()
        {
            //this.UriApi = "http://localhost:50809/"; // Local API
            // this.UriApi = "http://agendaexampleapi.azurewebsites.net/"; // Azure API
            this.UriApi = "http://192.168.91.137:1026/";
            this.mediaheader = new System.Net.Http.Headers.MediaTypeWithQualityHeaderValue("application/json");
        }

        public async Task<List<Parking>> GetContacts()
        {
            using (HttpClient client = new HttpClient())
            {
                //String petition = "api/Contacts";
                String petition = "v2/entities";
                client.BaseAddress = new Uri(this.UriApi);
                client.DefaultRequestHeaders.Accept.Clear();
                client.DefaultRequestHeaders.Accept.Add(mediaheader);
                HttpResponseMessage respuesta = await client.GetAsync(petition);
                if (respuesta.IsSuccessStatusCode)
                {
                    List<Parking> cList = await respuesta.Content.ReadAsAsync<List<Parking>>();
                    return cList;
                }
                else { return null; }
            }
        }

        public async Task<Parking> GetContactByID(int id)
        {
            using (HttpClient client = new HttpClient())
            {
                //String petition = "api/Contacts/" + id;
                String petition = "v2/entities/" + id;
                client.BaseAddress = new Uri(this.UriApi);
                client.DefaultRequestHeaders.Accept.Clear();
                client.DefaultRequestHeaders.Accept.Add(mediaheader);
                HttpResponseMessage respuesta = await client.GetAsync(petition);
                if (respuesta.IsSuccessStatusCode)
                {
                    Parking c = await respuesta.Content.ReadAsAsync<Parking>();
                    return c;
                }
                else { return null; }
            }
        }

        //public async Task AddContact(Plazas c)
        //{
        //    using (HttpClient client = new HttpClient())
        //    {
        //        //String peticion = "api/Contacts";
        //        String peticion = "v2/entities";
        //        //client.BaseAddress = new Uri(this.UriApi);
        //        //peticion = client.BaseAddress + peticion;
        //        //client.DefaultRequestHeaders.Accept.Clear();
        //        //client.DefaultRequestHeaders.Accept.Add(mediaheader);
        //        //await client.PostAsJsonAsync(peticion, c);

        //        client.BaseAddress = new Uri(this.UriApi);
        //        client.DefaultRequestHeaders.Accept.Clear();
        //        client.DefaultRequestHeaders.Accept.Add(mediaheader);
        //        await client.PostAsJsonAsync(peticion, c);
        //    }
        //}


        //public Contact AddContact(Contact c)
        //{

        //    using (HttpClient client = new HttpClient())
        //    {
        //        client.BaseAddress = new Uri("http://192.168.198.129:1026/");
        //        client.DefaultRequestHeaders.Accept.Clear();
        //        client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));

        //        HttpResponseMessage response = client.PostAsJsonAsync("v2/entities", c).Result;
        //        if (response.IsSuccessStatusCode)
        //        {
        //            return response.Content.ReadAsAsync<Contact>().Result;
        //        }
        //        return null;
        //    }
        //}

        //public async Task EditContact(Parking c)
        //{
        //    using (HttpClient client = new HttpClient())
        //    {
        //        //String peticion = "api/Contacts";
        //        String peticion = "v2/entities/attrs/Embarazado/value";
        //        client.BaseAddress = new Uri(this.UriApi);
        //        client.DefaultRequestHeaders.Accept.Clear();
        //        client.DefaultRequestHeaders.Accept.Add(mediaheader);
        //        await client.PutAsJsonAsync(peticion, c.Embarazado.value);
        //    }
        //}

        public async Task DeleteContact(string id)
        {
            using (HttpClient client = new HttpClient())
            {
                // String peticion = "api/Contacts/" + id;
                String peticion = "v2/entities/" + id;
                client.BaseAddress = new Uri(this.UriApi);
                client.DefaultRequestHeaders.Accept.Clear();
                client.DefaultRequestHeaders.Accept.Add(mediaheader);
                await client.DeleteAsync(peticion);
            }
        }
    }
}