﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using FiwareProyecto;
using System.ComponentModel.DataAnnotations.Schema;
using System.ComponentModel;

namespace FiwareProyecto.Models.ViewModels
{
    public class UserViewModel
    {   

        public int idUsuario { get; set; }

        [Required]
        [EmailAddress]
        [StringLength(100, ErrorMessage = "El {0} debe tener al menos {1} caracteres", MinimumLength = 1)]
        [Display(Name = "Correo Electrónico")]
        public string email { get; set; }
        public string nombre { get; set; }
        public string apellidos { get; set; }

        [Required(ErrorMessage = "Debe incluir un {0} Válido")]
        [DataType(DataType.PhoneNumber, ErrorMessage = "El campo debe ser un numero de teléfono válido")]
        [Range(600000000, 999999999)]
        [DisplayName("Telefono")]
        public int telefono { get; set; }
        public Nullable<System.DateTime> fechaAlta { get; set; }
        public Nullable<System.DateTime> fechaBaja { get; set; }
        public Nullable<System.DateTime> fechaBorrado { get; set; }
        public bool activo { get; set; }
        [Required]
        [Display(Name = "Contraseña")]
        [DataType(DataType.Password)]
        public string password { get; set; }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Reserva> Reserva { get; set; }
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Roles> Roles { get; set; }

    }




}